
#property copyright " 2009 BJF Trading Group"
#property link      "www.iticsoftware.com"

#define major   2
#define minor   1

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 OrangeRed
#property indicator_color2 SkyBlue
#property indicator_color3 OrangeRed
#property indicator_color4 SkyBlue
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1


extern string _tmp1_ = " --- Common ---";
extern int AccDigits = 5;
extern int MaxBars = 1000;


extern string _tmp2_ = " --- Divergence ---";
extern int LeftFractal.Period = 3;
extern int RightFractal.Period = 1;

extern int Width.Min = 1;
extern int Width.Max = 25;
extern int Height.Min = 15;
extern int Height.Max = 1000;


extern string _tmp3_ = " --- MACD ---";
extern int MACD.FastEMA = 12;
extern int MACD.SlowEMA = 26; 
extern int MACD.Signal = 9;
extern double BullishDiv.ResetAbove = 0.0;
extern double BearishDiv.ResetBelow = 0.0;


extern string _tmp4_ = " --- Graphic ---";
extern int Shift.Arrow = 20;
extern int Shift.Dot = 10;
extern int Shift.Line = 1;


extern string _tmp5_ = " --- Alerts ---";
extern int    SignalBar = 1;
extern bool   PopupOn  = true;
extern bool   SoundOn  = true;
extern string LongSignal = "alert.wav";
extern string ShortSignal = "alert.wav";
extern bool   MailOn   = true;


double UpperFr[];
double LowerFr[];
double UpperFr2[];
double LowerFr2[];

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

string prefix;
int RightFractal.Shift = 0;
datetime SignalTime = 0;

void init() 
{
  SetIndexBuffer(0, UpperFr);
  SetIndexBuffer(1, LowerFr);
  SetIndexBuffer(2, UpperFr2);
  SetIndexBuffer(3, LowerFr2);
  
  SetIndexStyle(0, DRAW_ARROW);
  SetIndexStyle(1, DRAW_ARROW);
  SetIndexStyle(2, DRAW_ARROW);
  SetIndexStyle(3, DRAW_ARROW);
    
  SetIndexArrow(0, 234);
  SetIndexArrow(1, 233);
  SetIndexArrow(2, 159);
  SetIndexArrow(3, 159);  
  
  SetIndexEmptyValue(0, 0.0);
  SetIndexEmptyValue(1, 0.0);
  SetIndexEmptyValue(2, 0.0);
  SetIndexEmptyValue(3, 0.0);
    
  prefix = WindowExpertName();
  
  clear();
}

void deinit()
{
  clear();
}

void start() 
{
  clear();

  //-----
      
  double fr0, fr1;
  double macd0, macd1;
  string obj_name;
  
  if (Width.Min <= 0) Width.Min = 1;
  
  
  int counted = IndicatorCounted();
  if (counted < 0) return (-1);
  
  if (counted > 0) counted--;
  int limit = Bars-counted;
  limit = MathMin(limit, Bars-Width.Max);
  limit = MathMin(limit, MaxBars);
  
  limit = MaxBars;
  
  for (int i=0; i < Bars; i++)
  {
    UpperFr[i] = 0.0;
    UpperFr2[i] = 0.0;
    
    LowerFr[i] = 0.0;
    LowerFr2[i] = 0.0;
  }
  
  //BEARISH divergence    
  for (i=RightFractal.Period+RightFractal.Shift; i < limit+RightFractal.Period+RightFractal.Shift; i++)
  {
    fr0 = iFractal(MODE_UPPER, RightFractal.Period, i);
    if (fr0 == 0) continue;
    
    macd0 = iMACD(NULL, 0, MACD.FastEMA, MACD.SlowEMA, MACD.Signal, PRICE_CLOSE, MODE_MAIN, 0);
    for (int j=0; j < RightFractal.Period; j++)
    {
      double macd = iMACD(NULL, 0, MACD.FastEMA, MACD.SlowEMA, MACD.Signal, PRICE_CLOSE, MODE_MAIN, i-j);
      if (j==0 || macd0 < macd) macd0 = macd;
    }
    
    for(j=i+1; j <= i+Width.Max; j++) 
    {
      macd1 = iMACD(NULL, 0, MACD.FastEMA, MACD.SlowEMA, MACD.Signal, PRICE_CLOSE, MODE_MAIN, j);
      if (macd1 <= BearishDiv.ResetBelow) break;
    
      fr1 = iFractal(MODE_UPPER, LeftFractal.Period, j);
      if (fr1 == 0) continue;
      if (fr1 >= fr0) break;
      if (j-i <= Width.Min) continue;
    
      if (Height.Min*Point*fpc() <= fr0-fr1 && fr0-fr1 <= Height.Max*Point*fpc()) 
      {
        if (macd1 > macd0)
        {         
          UpperFr[i] = High[i] + (Shift.Arrow-5)*Point*fpc();
          UpperFr2[j] = High[j] + Shift.Dot*Point*fpc();
          
          obj_name = prefix+"_u_" + Time[i];
          ObjectCreate(obj_name, OBJ_TREND, 0, Time[i], High[i]+Shift.Line*Point*fpc(), Time[j], High[j]+Shift.Line*Point*fpc());
          ObjectSet(obj_name, OBJPROP_RAY, false);
          ObjectSet(obj_name, OBJPROP_COLOR, indicator_color1);
          ObjectSet(obj_name, OBJPROP_STYLE, STYLE_DOT);
          
          break;
        }
      }
    }
  }

  //BULLISH divergence
  for (i=RightFractal.Period+RightFractal.Shift; i < limit+RightFractal.Period+RightFractal.Shift; i++) 
  {
    fr0 = iFractal(MODE_LOWER, RightFractal.Period, i);
    if (fr0 == 0) continue;
    
    macd0 = iMACD(NULL, 0, MACD.FastEMA, MACD.SlowEMA, MACD.Signal, PRICE_CLOSE, MODE_MAIN, 0);
    for (j=0; j < RightFractal.Period; j++)
    {
      macd = iMACD(NULL, 0, MACD.FastEMA, MACD.SlowEMA, MACD.Signal, PRICE_CLOSE, MODE_MAIN, i-j);
      if (j==0 || macd0 > macd) macd0 = macd;
    }

    for(j=i+1; j <= i+Width.Max; j++) 
    {
      macd1 = iMACD(NULL, 0, MACD.FastEMA, MACD.SlowEMA, MACD.Signal, PRICE_CLOSE, MODE_MAIN, j);
      if (macd1 >= BullishDiv.ResetAbove) break;

      fr1 = iFractal(MODE_LOWER, LeftFractal.Period, j);
      if (fr1 == 0) continue;

      if (fr1 <= fr0) break;
      if (j-i <= Width.Min) continue;

      if (Height.Min*Point*fpc() <= fr1-fr0 && fr1-fr0 <= Height.Max*Point*fpc())
      {                     
        if (macd1 < macd0) 
        {
          LowerFr[i] = Low[i] - Shift.Arrow*Point*fpc();
          LowerFr2[j] = Low[j] - Shift.Dot*Point*fpc();
          
          obj_name = prefix+"_l_" + Time[i];
          ObjectCreate(obj_name, OBJ_TREND, 0, Time[i], Low[i]-Shift.Line*Point*fpc(), Time[j], Low[j]-Shift.Line*Point*fpc());
          ObjectSet(obj_name, OBJPROP_RAY, false);
          ObjectSet(obj_name, OBJPROP_COLOR, indicator_color2);
          ObjectSet(obj_name, OBJPROP_STYLE, STYLE_DOT);
          
          break;
        }
      }
    }
  }
  
  //-----
  
  string msg;
   
  if (UpperFr[SignalBar] > 0)
  {
    if (Time[0] != SignalTime)
    {
      SignalTime = Time[0];

      msg = Symbol() + " " + TF2Str(Period()) + ": BEARISH divergence detected at " + 
        TimeToStr(TimeCurrent(), TIME_DATE|TIME_SECONDS);
    
      if (SoundOn) PlaySound(LongSignal);
      if (MailOn) SendMail(WindowExpertName(), msg);
      if (PopupOn) Alert(WindowExpertName() + " " + msg);
     }
   }

  if (LowerFr[SignalBar] > 0)
  {
    if (Time[0] != SignalTime)
    {
      SignalTime = Time[0];

      msg = Symbol() + " " + TF2Str(Period()) + ": BULLISH divergence detected at " + 
        TimeToStr(TimeCurrent(), TIME_DATE|TIME_SECONDS);
    
      if (SoundOn) PlaySound(ShortSignal);
      if (MailOn) SendMail(WindowExpertName(), msg);
      if (PopupOn) Alert(WindowExpertName() + " " + msg);
     }
   }  
}

void clear()
{
  int total = ObjectsTotal();  
  for (int i=total-1; i >= 0; i--) 
  {
    string name = ObjectName(i);
    if (StringFind(name, prefix) == 0) ObjectDelete(name);
  }
}


double iFractal(int mode, int period, int shift)
{
  int l = 0;
  int r = 0;

  if (mode == MODE_UPPER)
  {
    for (int i=1; i <= period; i++)
    {
      if (shift-i < 0) break;
      if (shift+i >= Bars) break;
      
      if (High[shift-i] < High[shift]) l++;
      if (High[shift+i] < High[shift]) r++;      
    }
    
    if (l == period && r == period) return (High[shift]);
  }

  if (mode == MODE_LOWER)
  {
    for (i=1; i <= period; i++)
    {
      if (shift-i < 0) break;
      if (shift+i >= Bars) break;
      
      if (Low[shift-i] > Low[shift]) l++;
      if (Low[shift+i] > Low[shift]) r++;      
    }
    
    if (l == period && r == period) return (Low[shift]);
  }
  
  return (0);
}

int fpc()
{
  if (AccDigits == 5) return (10);
  if (AccDigits == 6) return (100);
  return (1); 
}

string TF2Str(int period)
{
  switch (period) 
  {
    case PERIOD_M1: return("M1");
    case PERIOD_M5: return("M5");
    case PERIOD_M15: return("M15");
    case PERIOD_M30: return("M30");
    case PERIOD_H1: return("H1");
    case PERIOD_H4: return("H4");
    case PERIOD_D1: return("D1");
    case PERIOD_W1: return("W1");
    case PERIOD_MN1: return("MN");
 }
 
  return (Period());
}

